﻿SystemOrganization addCategory: #'Janken-sitou1986-Hand'!
SystemOrganization addCategory: #'Janken-sitou1986-Comparer'!
SystemOrganization addCategory: #'Janken-sitou1986-Rule'!

Object subclass: #Comparer
	instanceVariableNames: 'from to result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Janken-sitou1986-Comparer'!

!Comparer methodsFor: 'accessing' stamp: 'sumim 8/11/2016 21:59'!
from
	^from! !

!Comparer methodsFor: 'accessing' stamp: 'sumim 8/11/2016 21:59'!
result
	^result! !

!Comparer methodsFor: 'accessing' stamp: 'sumim 8/11/2016 21:59'!
to
	^to! !

Comparer subclass: #Reverse
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Janken-sitou1986-Comparer'!

!Reverse class methodsFor: 'instance creation' stamp: 'sumim 8/12/2016 00:37'!
source: source
	^self new initialize: source; yourself! !

!Reverse methodsFor: 'initialization' stamp: 'sumim 8/12/2016 00:32'!
initialize: hand
	source := hand.
	from := source to.
	to := source from.
	result := source result not! !

Comparer subclass: #Wins
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Janken-sitou1986-Comparer'!

!Wins class methodsFor: 'instance creation' stamp: 'sumim 8/11/2016 21:56'!
from: handClass1 to: handClass2
	^self new setFrom: handClass1 to: handClass2; yourself! !

!Wins methodsFor: 'accessing' stamp: 'sumim 8/11/2016 21:39'!
from
	^from! !

!Wins methodsFor: 'initialization' stamp: 'sumim 8/11/2016 21:41'!
initialize
	result := true! !

!Wins methodsFor: 'accessing' stamp: 'sumim 8/11/2016 21:40'!
result
	^result! !

!Wins methodsFor: 'private' stamp: 'sumim 8/11/2016 21:57'!
setFrom: handClass1 to: handClass2
	from := handClass1.
	to := handClass2! !

!Wins methodsFor: 'accessing' stamp: 'sumim 8/11/2016 21:39'!
to
	^to! !

Object subclass: #Hand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Janken-sitou1986-Hand'!

Hand subclass: #Choki
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Janken-sitou1986-Hand'!

!Choki methodsFor: 'printing' stamp: 'sumim 8/11/2016 21:34'!
printOn: stream
	stream nextPutAll: 'チョキ'!]lang[(37 3 1)0,5,0! !

Hand subclass: #Gu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Janken-sitou1986-Hand'!

!Gu methodsFor: 'printing' stamp: 'sumim 8/11/2016 21:34'!
printOn: stream
	stream nextPutAll: 'グー'!]lang[(37 2 1)0,5,0! !

!Hand methodsFor: 'printing' stamp: 'sumim 8/11/2016 21:35'!
printOn: stream
	self subclassResponsibility! !

Hand subclass: #Pa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Janken-sitou1986-Hand'!

!Pa methodsFor: 'printing' stamp: 'sumim 8/11/2016 21:34'!
printOn: stream
	stream nextPutAll: 'パー'!]lang[(37 2 1)0,5,0! !

Object subclass: #Rule
	instanceVariableNames: 'matches availableHands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Janken-sitou1986-Rule'!

!Rule class methodsFor: 'examples' stamp: 'sumim 8/13/2016 09:49'!
example
	"Rule example"
	| numOfPlayers rule |

	Transcript open.
	numOfPlayers := (UIManager default request: 'プレーヤー人数を入力してください:') asInteger.
	numOfPlayers ifNil: [^self].

	rule := Rule new: {Wins from: Gu to: Choki. Wins from: Choki to: Pa. Wins from: Pa to: Gu}.
	[	| hands winner |

		hands := Array streamContents: [:ss |
			(1 to: numOfPlayers) do: [:i |
				| hand |
				hand := rule createHand.
				Transcript cr; show: ('プレーヤー{1}: {2}' format: {i. hand}).
				ss nextPut: hand
			]
		].

		winner := rule play: hands.
		winner
			ifNotNil: [
				| index |
				index := hands indexOf: winner.
				Transcript cr; show: ('プレーヤー{1}の勝ちです' format: {index})]
			ifNil: [Transcript cr; show: '引き分けです'].

		Transcript cr; endEntry.

		(UIManager default confirm: '終了しますか？') ifTrue: [^self]

	] repeat!]lang[(112 16 303 5 193 5 3 5 53 6 64 7 29)0,5,0,5,0,5,0,5,0,5,0,5,0! !

!Rule class methodsFor: 'instance creation' stamp: 'sumim 8/11/2016 22:33'!
new: rules
	^self new setRules: rules; yourself! !

!Rule class methodsFor: 'instance creation' stamp: 'sumim 8/11/2016 21:54'!
rules: rules
	^self new setRules: rules; yourself! !

!Rule methodsFor: 'hand creation' stamp: 'sumim 8/12/2016 12:55'!
createHand
	^availableHands atRandom new! !

!Rule methodsFor: 'private' stamp: 'sumim 8/12/2016 12:58'!
find: triplet
	| hand1 hand2 expectedResult |
	hand1 := triplet first.
	hand2 := triplet second.
	expectedResult := triplet last.
	^ (matches at: (self generateMatchKey: {hand1 class. hand2 class}) ifAbsent: []) ifNotNil: [:rule | rule result = expectedResult ifTrue: [rule]]! !

!Rule methodsFor: 'private' stamp: 'sumim 8/11/2016 22:18'!
generateMatchKey: hands
	^'{1}=>{2}' format: hands! !

!Rule methodsFor: 'playing' stamp: 'sumim 8/12/2016 00:59'!
play: hands
	| winners |
	winners := hands select: [:hand | hands allSatisfy: [:target | target == hand or: [self win: {hand. target}]]].
	^winners size = 1 ifTrue: [winners first]! !

!Rule methodsFor: 'private' stamp: 'sumim 8/12/2016 00:39'!
setRules: comparers
	matches := ((comparers gather: [:rule | {rule. Reverse source: rule}])
			groupBy: [:rule | self generateMatchKey: {rule from. rule to}]
			having: #notEmpty) associations
		inject: Dictionary new into: [:dic :group |
			dic at: group key put: group value last; yourself].
	availableHands := (comparers gather: [:rule | {rule from. rule to}]) asSet asArray! !

!Rule methodsFor: 'private' stamp: 'sumim 8/11/2016 23:56'!
win: pair
	^((self find: {pair first. pair second. true}) ifNil: [self find: {pair second. pair first. false}]) notNil! !
